<template>
  <div>
    <h1>vue-flask-maps</h1>
    <hr>
    <alert :message=message v-if="showMessage"></alert>
    <gmap-map
      :center="center"
      :zoom="13"
      :options="{disableDefaultUI: true}"
      :mapConfig="styles"
      style="width:100%;  height: 400px;">
      <gmap-marker
        :key="index"
        v-for="(m, index) in markers"
        :icon="icon"
        :position="m.position"
        @click="center=m.position">
       </gmap-marker>
    </gmap-map>
  </div>
</template>

<script>
import { mapSettings, POINT_MARKER_ICON_CONFIG } from '@/constants/mapSettings';
import axios from 'axios';
import Alert from './Alert.vue';

export default {
  name: 'GoogleMap',
  data() {
    return {
      // default to Montreal to keep it simple
      // change this to whatever makes sense
      center: { lat: 50.508, lng: -63.587 },
      markers: [{ position: { lat: 65.0, lng: -63.0 } }],
      icon: POINT_MARKER_ICON_CONFIG,
      styles: mapSettings,
    };
  },
  components: {
    alert: Alert,
  },
  mounted() {
    this.getMap();
    // this.addMarker();
    setInterval(this.refresh_jobs, 1000);
  },

  methods: {
    getMap() {
      // eslint-disable-next-line
      const path = '/map';
      axios.get(path)
        .then((res) => {
          this.center = res.data.center;
          this.markers = res.data.markers;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
        });
    },
    addMarker() {
      if (this.currentPlace) {
        const marker = {
          lat: 45.5,
          lng: -73.5,
        };
        this.markers.push({ position: marker });
        this.places.push(this.currentPlace);
        this.center = marker;
        this.currentPlace = null;
      }
    },
    refresh_jobs() {
      const jobs = this.markers;
      if (jobs.length > 0) {
        jobs.forEach((item, index) => {
          this.get_job_from_api(item.job_id, index);
        });
      }
    },
    get_job_from_api(jobId, index) {
      this.loading = true;
      // eslint-disable-next-line
      const path = '/markers/'+index;
      axios.get(path)
        .then((response) => {
          this.markers.splice(index, 1, response.data.marker); // splice will trigger vue refresh
          this.loading = false;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
          this.loading = false;
        });
    },
    // receives a place object via the autocomplete component
    setPlace(place) {
      this.currentPlace = place;
    },
  },
};
</script>
